<template>
	<div>
		<hr />
		<table class="table" v-if="list.length > 0">
			<thead>
				<tr>
					<th
						scope="col"
						@click="ordenarListado(orden.numero)"
						style="cursor: pointer"
					>
						N° de Título
					</th>
					<th scope="col">Fecha</th>
					<th scope="col">Nombre y Apellido</th>
					<th
						scope="col"
						@click="ordenarListado(orden.numero)"
						style="cursor: pointer"
					>
						N° de Resolucion Cargo Deudor
					</th>
					<th scope="col">Estado</th>
					<th scope="col">Acciones</th>
				</tr>
			</thead>
			<tbody>
				<tr v-for="elem in list" :value="elem" :key="elem.id_titulo_ejec">
					<td v-text="elem.id_titulo_ejec"></td>
					<td v-text="elem.fecha"></td>
					<td v-text="elem.ayn_o_razon_social"></td>
					<td
						v-text="elem.nro_resolucion + ' / ' + elem.periodo_resolucion"
					></td>
					<td v-text="elem.d_estado"></td>
					<td>
						<button
							type="button"
							@click="selectTituloEjecutivo(elem)"
							class="btn btn-principal p-0 px-1 mb-2 mt-0"
							title="Editar"
						>
							<!-- EDITAR BOTON-->
							<i class="bi bi-pencil-square"></i>
						</button>
					</td>
				</tr>
			</tbody>
		</table>
		<div v-else class="alert alert-secondary" role="alert">
			No hay elementos para mostrar
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";

// Entities
import type { Titulo } from "@/entities/Titulo";

// Stores
import { mapState, mapStores } from "pinia";
import { useTitulosStore } from "@/stores/titulos";

class Orden {
	myObjKey: string;
	orden: string;
	constructor(myObjKey: string, orden: string) {
		this.myObjKey = myObjKey;
		this.orden = orden;
	}
}

export default defineComponent({
	name: "ListadoTitulos",
	data() {
		return {
			orden: {
				numero: new Orden("id_titulo_ejec", "D"),
				resolucion: new Orden("periodo_resolucion", "D"),
				expt: new Orden("id_titulo_ejec", "D"),
			},
		};
	},
	computed: {
		...mapState(useTitulosStore, {
			list: "listadoTitulos",
		}),
		...mapStores(useTitulosStore),
	},
	mounted() {},
	methods: {
		selectTituloEjecutivo(elem: Titulo) {
			this.$emit("updateTitulo", elem);
		},
		ordenarListado(orden: Orden) {
			this.titulosStore.ordenarListado(orden.myObjKey, orden.orden);
			if (orden.orden == "A") {
				orden.orden = "D";
			} else if (orden.orden == "D") {
				orden.orden = "A";
			}
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
